package org.jvnet.substance.swingx;

import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JComponent;
import javax.swing.SwingConstants;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicLookAndFeel;

import org.jdesktop.swingx.plaf.basic.BasicMonthViewUI;
import org.jvnet.substance.SubstanceGradientBackgroundDelegate;
import org.jvnet.substance.SubstanceImageCreator;
import org.jvnet.substance.theme.SubstanceTheme;
import org.jvnet.substance.utils.SubstanceCoreUtilities;
import org.jvnet.substance.utils.SubstanceSizeUtils;

public class SubstanceMonthViewUI extends BasicMonthViewUI {
	/**
	 * Delegate for painting the background.
	 */
	private static SubstanceGradientBackgroundDelegate backgroundDelegate = new SubstanceGradientBackgroundDelegate();

	public static ComponentUI createUI(JComponent c) {
		return new SubstanceMonthViewUI();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jdesktop.swingx.plaf.basic.BasicMonthViewUI#installDefaults()
	 */
	@Override
	protected void installDefaults() {
		super.installDefaults();
		this.monthDownImage = SubstanceImageCreator.getArrowIcon(
				SubstanceSizeUtils.getArrowIconWidth(), SubstanceSizeUtils
						.getArrowIconHeight(), SubstanceSizeUtils
						.getArrowStrokeWidth(), SwingConstants.WEST,
				SubstanceCoreUtilities.getActiveTheme(this.monthView, true));
		this.monthUpImage = SubstanceImageCreator.getArrowIcon(
				SubstanceSizeUtils.getArrowIconWidth(), SubstanceSizeUtils
						.getArrowIconHeight(), SubstanceSizeUtils
						.getArrowStrokeWidth(), SwingConstants.EAST,
				SubstanceCoreUtilities.getActiveTheme(this.monthView, true));
		BasicLookAndFeel.installColors(this.monthView,
				"JXMonthView.background", "JXMonthView.foreground");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jdesktop.swingx.plaf.basic.BasicMonthViewUI#paintMonthStringBackground(java.awt.Graphics,
	 *      int, int, int, int)
	 */
	@Override
	protected void paintMonthStringBackground(Graphics g, int x, int y,
			int width, int height) {
		SubstanceTheme theme = SubstanceCoreUtilities.getDefaultTheme(
				this.monthView, true);
		backgroundDelegate.update(g, this.monthView, new Rectangle(x, y, width,
				height), theme.getHighlightBackgroundTheme(), true);
	}
}
